﻿"use strict";

angular.module("monApp")

.controller("AdapterController", ["$rootScope", "$scope", "$translate",
function ($rootScope, $scope, $translate) {

	$rootScope.chartType = "adapter";

	var server = $rootScope.getActiveServer();
	this.ServerId = server.sid;
	this.ServerName = server.sname;

	this.ActiveAdapter = $rootScope.getActiveAdapter();

	$scope.chartDataSet = [];
	$scope.chartData = [];
	$scope.lastDateTime = new Date();

	var isAdapterDataInit = false;
	var isChartInitTabAdapters = false;

	function getAdapterData() {

		var activeAdapter = $rootScope.getActiveAdapter();

		if (!isAdapterDataInit && activeAdapter) {

			for (var j = 0; j < activeAdapter.load.length; j++) {

				var time1 = new Date(activeAdapter.load[j][0]);
				var temp = [time1.getTime(), activeAdapter.load[j][1]];
				$scope.chartData.push(temp);
			}

			isAdapterDataInit = true;
		} else if (activeAdapter) {

			//TODO костыль для двух точек
			var time = new Date(server.timeLocalStr);
			if ((time.getTime() - $scope.lastDateTime.getTime()) < $rootScope.updateIntervalMs)
				return;

			$scope.lastDateTime = time;

			var currentMbps = 0;
			if (activeAdapter.currentMbps)
				currentMbps = activeAdapter.currentMbps;

			$scope.chartData.push([time.getTime(), currentMbps]);
		}

		if ($scope.chartData.length >= $rootScope.totalPoints) {
			$scope.chartData.shift();
		}
	}

	function updateAdapterChart() {

		var activeServer = $rootScope.getActiveAdapter();

		if ($rootScope.chartType !== "adapter")
			return;

		getAdapterData();

		if ($('#chart_adapt').is(':visible') && activeServer.maxMbps) {

			if (!isChartInitTabAdapters) {

				if ($rootScope.chartType !== "adapter")
					return;

				$rootScope.options = getAdaptersChartOptions($translate);

				$scope.chartDataset = [
					{ label: $translate.instant('CHART_ADAPTER_LINE1'), data: $scope.chartData, color: "#00FF00" }
				];
				isChartInitTabAdapters = true;
			}

			try {
				if ($rootScope.chartType === "adapter") {
					$scope.chartDataset = [
						{ label: $translate.instant('CHART_ADAPTER_LINE1'), data: $scope.chartData, color: "#00FF00" }];

					$.plot($("#chart_adapt"), $scope.chartDataset, $rootScope.options);
				}
			} catch (e) {

			}
		}

		if ($rootScope.chartType !== "adapter")
			return;

		if (!isChartInitTabAdapters)
			setTimeout(updateAdapterChart, 0);
		else
			setTimeout(updateAdapterChart, $rootScope.updateIntervalMs);
	}

	updateAdapterChart();
}
]);

