﻿"use strict";

angular.module("monApp", ["pascalprecht.translate", "ngRoute", "infinite-scroll", "ngCookies"])

.config(["$translateProvider",
function ($translateProvider) {

	$translateProvider
		.translations('ru', translation_ru)
		.translations('en', translation_en)
		.preferredLanguage('ru');
}])

.config(function ($routeProvider, $locationProvider) {
	$routeProvider
		.when("/", {
			templateUrl: "Views/mainView.html?v=24",
			controller: "MainController"
		})
		.when("/log", {
			templateUrl: "Views/logView.html?v=24",
			controller: "MainController"
		})
		.when("/settings", {
			templateUrl: "Views/settingsView.html?v=24",
			controller: "MainController"
		})
		.when("/server/:id", {
			templateUrl: "Views/serverView.html?v=24",
			controller: "MainController"
		})
		.when("/server/:id/camera/:camid", {
			templateUrl: "Views/cameraView.html?v=24",
			controller: "MainController"
		})
		.when("/server/:id/adapter/:adapterid", {
			templateUrl: "Views/adapterView.html?v=24",
			controller: "MainController"
		})
		.when("/faq", {
			templateUrl: "Views/faqView.html?v=24",
			controller: "MainController"
		})
		.otherwise({
			redirectTo: '/'
		});

	// use the HTML5 History API
	$locationProvider.html5Mode(true);
})

.directive("ngEnter", function () {
	return function (scope, element, attrs) {
		element.bind("keydown keypress", function (event) {
			if (event.which === 13) {
				scope.$apply(function () {
					scope.$eval(attrs.ngEnter);
				});

				event.preventDefault();
			}
		});
	};
});