﻿"use strict";

angular.module("monApp")

.controller("JumbotronController", ["$translate", "$rootScope", "$cookies", "$cookieStore", "$location", "$scope", "$http",
function ($translate, $rootScope, $cookies, $cookieStore, $location, $scope, $http) {

	$scope.jCtrl = this;

	$scope.path = $location.protocol() + "://" + $location.host();

	if ($location.port() === 8191 || $location.port() === 8889) {
		$scope.path += ":" + $location.port();
	} else {
		$scope.path += ":" + 8889;
	}

	//change language
	$scope.changeLanguageToApp = function (langKey) {

		$scope.language = langKey;
		$scope.jCtrl.activeLang = langKey;

		$rootScope.activeLocale = langKey;
		$translate.use(langKey);

		$rootScope.$emit('handleEmit', { message: "langChange" });
	};


	//save language
	this.applyLanguage = function () {

		if ($scope.isLanguageFromServerReceived === false)
			return;

		var reqSet = {
			method: "GET",
			url: $scope.path + "/api/ChangeLanguage",
			params: {
				newLanguage: $scope.language
			},
			headers: {
				'Content-Type': undefined
			}
		}

		$http(reqSet)
			.success(function () {
			})
			.error(function () {
			});
	};

	//change language
	this.changeLanguage = function (langKey) {

		$scope.changeLanguageToApp(langKey);
		this.applyLanguage();
	};


	//get language
	this.getLanguage = function () {

		var reqGet = {
			method: "GET",
			url: $scope.path + "/api/GetLanguage",
			headers: {
				'Content-Type': undefined
			}
		}

		$http(reqGet)
			.success(function (data) {

				$scope.isLanguageFromServerReceived = true;

				if (!data)
					return;

				$scope.changeLanguageToApp(data);
			})
			.error(function () {
			});
	};

	this.logOut = function () {

		$rootScope.pass = undefined;

		$scope.language = undefined;
		this.applyLanguage();

		$cookieStore.remove('pass');

		var path1 = $location.protocol() + "://" + $location.host() + ":" + $location.port();

		window.location = path1;
	};
	$rootScope.$on('handleEmit', function (event, args) {
		$rootScope.$broadcast('handleBroadcast', args);
	});

	//так как код запросов работает асинхронно, а нам необходимо выставить какой-то начальный язык в браузере
	//то мы будем пытаться брать язык из куки/языка браузера до тех пор, пока нам не придет сохраненный язык
	//с сервера. Но до тех пор, пока сохраненный язык не пришел, нельзя отправлять текущий язык на сохранение.
	$scope.isLanguageFromServerReceived = false;
	this.getLanguage();

	var locale = $scope.language;
	if (locale === null || locale === undefined)
		locale = $cookieStore.get('locale');

	if (locale) {
		$scope.changeLanguageToApp(locale);
	}
	else {
		var userLang = navigator.language || navigator.userLanguage;
		if (userLang === "ru-RU")
			$scope.changeLanguageToApp("ru");
		else {
			$scope.changeLanguageToApp("en");
		}

		this.applyLanguage();
	}
}]);