﻿"use strict";

angular.module("monApp")

.controller("ServerController", ["$rootScope", "$scope", "$translate", "$http", "$location",
function ($rootScope, $scope, $translate, $http, $location) {

	this.ActiveServer = $rootScope.getActiveServer();

	$scope.isLoading = false;
	$scope.detachStatus = null;
	$scope.detachPressed = null;
	$rootScope.chartType = "none";

	$scope.chartData = [];
	$scope.chartData2 = [];
	$scope.chartDataSet = [];
	$scope.lastDateTime = new Date();
	
	const supportedClientTypes = ["desktop", "mobile", "web"];
	$scope.getCorrectedClientType = function (clientType) {
		if (typeof clientType != "string")
			return supportedClientTypes[0];
		
		let clientTypeLowercase = clientType.toLowerCase();
		if (supportedClientTypes.includes(clientTypeLowercase))
			return clientTypeLowercase;
		
		return supportedClientTypes[0];
	}

	this.setTab = function (tabId) {
	    this.tab = tabId;

	    var isChartInitTabMemory = false;
	    var getDataInitTabMemory = false;
	    var getDataInitTabCpu = false;
	    var isChartInitTabCpu = false;
	    var getDataInitTabCpuMain = false;
	    var isChartInitTabCpuMain = false;

	    function getMemoryData() {

	        var activeServer = $rootScope.getActiveServer();

	        if (!getDataInitTabMemory && activeServer) {

	            for (var j = 0; j < activeServer.mem.length; j++) {

	                var time1 = new Date(activeServer.mem[j][0]);
	                var temp = [time1.getTime(), (activeServer.mem[j][1] / 1024).toFixed(2)];
	                $scope.chartData.push(temp);
	            }

	            for (var k = 0; k < activeServer.servMem.length; k++) {

	                var time2 = new Date(activeServer.servMem[k][0]);
	                var temp2 = [time2.getTime(), (activeServer.servMem[k][1] / 1024).toFixed(2)];
	                $scope.chartData2.push(temp2);
	            }

	            getDataInitTabMemory = true;
	        } else if (activeServer) {

	            //TODO костыль для двух точек
	            var time = new Date(activeServer.timeLocalStr);
	            if ((time.getTime() - $scope.lastDateTime.getTime()) < $rootScope.updateIntervalMs)
	                return;

	            $scope.lastDateTime = time;

	            var mem = 0;
	            if (activeServer.computerRamMb)
	                mem = (activeServer.computerRamMb / 1024).toFixed(2);

	            var mem1 = 0;
	            if (activeServer.serverRam)
	                mem1 = (activeServer.serverRam / 1024).toFixed(2);

	            $scope.chartData.push([time.getTime(), mem]);
	            $scope.chartData2.push([time.getTime(), mem1]);
	        }

	        if ($scope.chartData.length >= $rootScope.totalPoints) {
	            $scope.chartData.shift();
	            $scope.chartData2.shift();
	        }
	    }

	    function updateMemoryChart() {

	        var activeServer = $rootScope.getActiveServer();

	        if ($rootScope.chartType !== "mem")
	            return;

	        getMemoryData();

	        if ($('#chart_mem').is(':visible') && activeServer.totalRamMb) {

	            $scope.isLoading = false;

	            if (!isChartInitTabMemory) {

	                $rootScope.options = getMemoryChartOptions($translate, activeServer);

	                if ($rootScope.chartType !== "mem")
	                    return;

	                $scope.chartDataset = [
                        { label: $translate.instant('CHART_MEM_LINE1'), data: $scope.chartData, color: "#00FF00" },
                        { label: $translate.instant('CHART_MEM_LINE2'), data: $scope.chartData2, color: "#0000FF" }
	                ];
	                isChartInitTabMemory = true;
	            }

	            try {
	                if ($rootScope.chartType === "mem") {
	                    $scope.chartDataset = [
                            { label: $translate.instant('CHART_MEM_LINE1'), data: $scope.chartData, color: "#00FF00" },
                            { label: $translate.instant('CHART_MEM_LINE2'), data: $scope.chartData2, color: "#0000FF" }];

	                    $.plot($("#chart_mem"), $scope.chartDataset, $rootScope.options);
	                }
	            } catch (e) {

	            }
	        }

	        if ($rootScope.chartType === "mem") {
	            if (!isChartInitTabMemory)
	                setTimeout(updateMemoryChart, 0);
	            else
	                setTimeout(updateMemoryChart, $rootScope.updateIntervalMs);
	        }
	    }

	    function getCpuData() {

	        var activeServer = $rootScope.getActiveServer();

	        if (!getDataInitTabCpu && activeServer) {

	            for (var j = 0; j < activeServer.cpu.length; j++) {

	                var time1 = new Date(activeServer.cpu[j][0]);
	                var temp = [time1.getTime(), activeServer.cpu[j][1]];
	                $scope.chartData.push(temp);
	            }

	            for (var i = 0; i < activeServer.servCpu.length; i++) {

	                var time2 = new Date(activeServer.servCpu[i][0]);
	                var temp1 = [time2.getTime(), activeServer.servCpu[i][1]];
	                $scope.chartData2.push(temp1);
	            }

	            getDataInitTabCpu = true;
	        } else if (activeServer) {

	            //TODO костыль для двух точек
	            var time = new Date(activeServer.timeLocalStr);
	            if ((time.getTime() - $scope.lastDateTime.getTime()) < $rootScope.updateIntervalMs)
	                return;

	            $scope.lastDateTime = time;

	            var mem = 0;
	            if (activeServer.computerCpu)
	                mem = activeServer.computerCpu;

	            var mem1 = 0;
	            if (activeServer.serverCpu)
	                mem1 = activeServer.serverCpu;

	            $scope.chartData.push([time.getTime(), mem]);
	            $scope.chartData2.push([time.getTime(), mem1]);
	        }

	        if ($scope.chartData.length >= $rootScope.totalPoints) {
	            $scope.chartData.shift();
	            $scope.chartData2.shift();
	        }
	    }

	    function updateCpuChart() {

	        var activeServer = $rootScope.getActiveServer();

	        if ($rootScope.chartType !== "cpu")
	            return;

	        getCpuData();

	        if ($('#chart_cpu').is(':visible') && activeServer.totalRamMb) {

	            $scope.isLoading = false;

	            if (!isChartInitTabCpu) {

	                if ($rootScope.chartType !== "cpu")
	                    return;

	                $rootScope.options = getCpuChartOptions();

	                $scope.chartDataset = [
                        { label: $translate.instant('CHART_CPU_LINE1'), data: $scope.chartData, color: "#00FF00" },
                        { label: $translate.instant('CHART_CPU_LINE2'), data: $scope.chartData2, color: "#0000FF" }
	                ];

	                isChartInitTabCpu = true;
	            }

	            try {
	                if ($rootScope.chartType === "cpu") {

	                    $scope.chartDataset = [
                            { label: $translate.instant('CHART_CPU_LINE1'), data: $scope.chartData, color: "#00FF00" },
                            { label: $translate.instant('CHART_CPU_LINE2'), data: $scope.chartData2, color: "#0000FF" }
	                    ];

	                    $.plot($("#chart_cpu"), $scope.chartDataset, $rootScope.options);
	                }
	            } catch (e) {

	            }
	        }

	        if ($rootScope.chartType !== "cpu")
	            return;

	        if (!isChartInitTabCpu)
	            setTimeout(updateCpuChart, 0);
	        else
	            setTimeout(updateCpuChart, $rootScope.updateIntervalMs);
	    }

	    function getCpuDataMain() {

	        var activeServer = $rootScope.getActiveServer();

	        if (!getDataInitTabCpuMain && activeServer) {

	            for (var j = 0; j < activeServer.cpu.length; j++) {

	                var time1 = new Date(activeServer.cpu[j][0]);
	                var temp = [time1.getTime(), activeServer.cpu[j][1]];
	                $scope.chartData.push(temp);
	            }

	            getDataInitTabCpuMain = true;
	        } else if (activeServer) {

	            //TODO костыль для двух точек
	            var time = new Date(activeServer.timeLocalStr);
	            if ((time.getTime() - $scope.lastDateTime.getTime()) < $rootScope.updateIntervalMs)
	                return;

	            $scope.lastDateTime = time;

	            var mem = 0;
	            if (activeServer.computerCpu)
	                mem = activeServer.computerCpu;

	            $scope.chartData.push([time.getTime(), mem]);
	        }

	        if ($scope.chartData.length >= $rootScope.totalPoints) {
	            $scope.chartData.shift();
	        }
	    }

	    function updateCpuChartMain() {

	        var activeServer = $rootScope.getActiveServer();

	        if ($rootScope.chartType !== "cpuMain")
	            return;

	        getCpuDataMain();

	        if ($('#chart_cpu_main').is(':visible') && activeServer.totalRamMb) {

	            $scope.isLoading = false;

	            if (!isChartInitTabCpuMain) {

	                if ($rootScope.chartType !== "cpuMain")
	                    return;

	                $rootScope.options = getCpuMainChartOptions();

	                $scope.chartDataset = [
                        { label: $translate.instant('CHART_CPU_LINE1'), data: $scope.chartData, color: "#00FF00" }
	                ];

	                isChartInitTabCpuMain = true;
	            }

	            try {
	                if ($rootScope.chartType === "cpuMain") {

	                    $scope.chartDataset = [
                            { label: $translate.instant('CHART_CPU_LINE1'), data: $scope.chartData, color: "#00FF00" }
	                    ];

	                    $.plot($("#chart_cpu_main"), $scope.chartDataset, $rootScope.options);
	                }
	            } catch (e) {

	            }
	        }

	        if ($rootScope.chartType !== "cpuMain")
	            return;

	        if (!isChartInitTabCpuMain)
	            setTimeout(updateCpuChartMain, 0);
	        else
	            setTimeout(updateCpuChartMain, $rootScope.updateIntervalMs);
	    }

		//memory charts
		if (tabId === 3) {

			$rootScope.chartType = "mem";

			isChartInitTabMemory = false;
			getDataInitTabMemory = false;

			$scope.chartData = [];
			$scope.chartData2 = [];
			$scope.lastDateTime = new Date();

			updateMemoryChart();
		}
			//cpu charts
		else if (tabId === 2) {

			$rootScope.chartType = "cpu";

			$scope.chartData = [];
			$scope.chartData2 = [];
			$scope.lastDateTime = new Date();

			getDataInitTabCpu = false;
			isChartInitTabCpu = false;

			updateCpuChart();
		}
			//main server info tab + chart cpu main
		else if (tabId === 1) {
			$rootScope.chartType = "cpuMain";

			$scope.chartData = [];
			$scope.lastDateTime = new Date();

			getDataInitTabCpuMain = false;
			isChartInitTabCpuMain = false;

			updateCpuChartMain();
		}
	};

	this.isSet = function (tabId) {
		return this.tab === tabId;
	};

	this.Detach = function () {
		$scope.detachPressed = null;
		var serverId = this.ActiveServer.sid;
		var path1 = $location.protocol() + "://" + $location.host();

		if ($location.port() === 8191 || $location.port() === 8889) {
			path1 += ":" + $location.port();
		} else {
			path1 += ":" + 8889;
		}
		var url = path1 + "/api/DetachServer";

		var jsonData = JSON.stringify(
		{
			Login: $rootScope.login.toString(),
			Password: $rootScope.pass.toString(),
			Data: serverId
		});

		var req = {
			method: 'POST',
			url: url,
			headers: {
				'Content-Type': "application/json"
			},
			data: jsonData,
			rnd: new Date().getTime()
		}

		$http(req).
			success(function (data) {
				$scope.detachStatus = true;
				$scope.detachPressed = true;
			})
			.error(function (data) {
				$scope.detachStatus = false;
				$scope.detachPressed = true;
			});
	};

	this.setTab(1);
}
]);