﻿"use strict";

angular.module("monApp")

.controller("SettingsController", ["$scope", "$http", "$location", "$rootScope", "$translate", "$cookies", "$cookieStore",
function ($scope, $http, $location, $rootScope, $translate, $cookies, $cookieStore) {

	$rootScope.chartType = "none";

	this.setTab = function (tabId) {
		this.tab = tabId;
	};

	this.isSet = function (tabId) {
		return this.tab === tabId;
	};

	this.setTab(1);

	$scope.info = null;

	$scope.path = $location.protocol() + "://" + $location.host();

	if ($location.port() === 8191 || $location.port() === 8889) {
		$scope.path += ":" + $location.port();
	} else {
		$scope.path += ":" + 8889;
	}

	$scope.getActualParams = function () {

		var reqGet = {
			method: "GET",
			url: $scope.path + "/api/GetEmailSettings",
			params: {
				login: $rootScope.login,
				pass: $rootScope.pass,
				rnd: new Date().getTime()
			},
			headers: {
				'Content-Type': undefined
			}
		}

		$http(reqGet)
			.success(function (data) {

				if (!data)
					return;

				$scope.info = {
					googleAddress: data.GoogleAddress,
					yandexAddress: data.YandexAddress,
					addressto: data.AdressTo,
					addressfrom: data.AdressFrom,
					smtpserveraddress: data.SmtpServerAdress,
					smtpserverport: data.SmtpServerPort === -1 ? undefined : data.SmtpServerPort,
					smtpAuthorizationType: data.SmtpAuthorizationType,
					smtpserverpass: data.SmtpServerPass,
					locale: data.LanguageLocale,
					sendServerType: data.SendServerType,
					sendCameraType: data.SendCameraType,
					sendOtherType: data.SendOtherType
				};
			})
				.error(function () {
				});

	};

	this.applyAuth = function () {

		var info = $scope.info;

		if (info.pass !== $scope.emailReg2) {
			$scope.IsMatch = true;
			return;
		}

		$scope.IsMatch = false;

		$scope.progressText = "";

		if (!info.pass)
			info.pass = "";

		var reqSet = {
			method: "GET",
			url: $scope.path + "/api/SetAuth",
			params: {
				login: $rootScope.login,
				pass: $rootScope.pass,
				newLogin: $rootScope.login,
				newPass: info.pass,
				rnd: new Date().getTime()
			},
			headers: {
				'Content-Type': undefined
			}
		}

		$http(reqSet)
			.success(function () {

				$scope.info = null;
				$scope.emailReg2 = null;

				$rootScope.pass = sha1(info.pass);
				$cookieStore.remove('pass');
				$scope.progressText = $translate.instant('SETTINGS.SUCCESS_SAVE_PASS');
				$scope.getActualParams();
			})
			.error(function () {
				$scope.progressText = $translate.instant('SETTINGS.FAIL_SAVE_PASS');
			});
	};

	$scope.getActualParams();
}]);